/*Copyright (C) 2006  Jean-Franois Geyelin*/

// C Source File
// Created 6/18/2005; 3:18:42 PM

#include "All.h"


//Generate Sprite.c
void generateSprites(unsigned short *s);
//Vectors.c
short getAngle(short, short);
short simplifyAngle(short);
//Collision.c
void handleCollisions(Player *);
//Move Player.c
void getKeyInput(void);
void movePlayer(Player *);
//Map Sprite.c
void createMapSprite(void);
//Menu.c
char menu(int *);
//Draw Everything.c
void drawEverything(Player *, char *, unsigned char [][128]);
void copyBufferToScreen(void);
//Draw Number.c
void drawNumber(int, char, char, char *);
//Init.c
void initAll();
//Decompress sprites.c
void decompressTiles();
void decompressMasks();
//Transition.c
void transition(void);
//Save File.c
char createFile(void);
SaveFile* getFilePtrToSave(void);
char fileExists(void);
void initNewFile(void);
//Record Ghost.c
void recordGhost(unsigned char);
void copyNewGhostToFile(void);
//Read Ghost.c
unsigned char readGhost(void);
//Draw Count Down.c
void drawCountDown(void);
//Draw Sexy String.c
void drawSexyString(const char*, char *);
//Pause Game.c
void pauseGame(void);

//Globals
AllocatedMem		*allocatedMem;
unsigned char 	(*mapArray)[64];
 
 
 
/*

*/
void needMoreMemoryMsg() {
		ST_helpMsg("Need around 150ko of free RAM");
		exit(0);	
}


/*

*/
void _main() {
 	allocatedMem = malloc(sizeof(AllocatedMem));
	if (!allocatedMem) {
		needMoreMemoryMsg();
	}

	void *decompressedSprites = malloc(sizeof(DecompressedTiles) + sizeof(DecompressedMasks));
	if (!decompressedSprites) {
		free(allocatedMem);
		needMoreMemoryMsg();
	}
	allocatedMem->decompressedTiles = (DecompressedTiles*)  decompressedSprites;
	allocatedMem->decompressedMasks = (DecompressedMasks*) (decompressedSprites + sizeof(DecompressedTiles));
	
	
	homeScreenSave//cf Define.h
	intToDummyHandlers//cf Define.h
	
	decompressTiles();
	decompressMasks();
	
	if (fileExists()) {
		
	}
	else
	{
		if (createFile()) {
			initNewFile();
		}
		else
		{
			clrscr();
			FontSetSys(0);
			printf("Scores and ghosts can't be saved\n\nPress Enter");
			while (!_keytest(RR_ENTER));
			allocatedMem->saveFile = NULL;
			goto AA;
		}
	}
	
	allocatedMem->saveFile = getFilePtrToSave();
	AA:;


	int mapChosen=mapChosen;
	Player *p = &allocatedMem->p;
	p->mapNumber=0;
	p->raceMode=THREE_LAPS;
	while (menu(&mapChosen)) {

		initAll(allocatedMem);
		
		drawEverything(p,allocatedMem->buffer,allocatedMem->map);	
		if (TI89)
		memmove(allocatedMem->buffer,allocatedMem->buffer+5+20*30,30*100);
		transition();

		drawCountDown();
		
		while (!(_keytest(RR_ESC) || p->hasFinishedRacing)) {
			getKeyInput();
			movePlayer(p);
			if (allocatedMem->playGhost) {
				allocatedMem->ghostPlayer.keyPressed = readGhost();
				movePlayer(&allocatedMem->ghostPlayer);
			}
			if (allocatedMem->recordGhost) {
				recordGhost(p->keyPressed);
			}
			drawEverything(p,allocatedMem->buffer,allocatedMem->map);		
			handleCollisions(p);
			handleCollisions(&allocatedMem->ghostPlayer);
			drawNumber(p->currentFPL, 6, 0+20*TI89, allocatedMem->buffer);
			drawNumber(p->bestFPL, 6, 8+20*TI89, allocatedMem->buffer);
			//drawNumber(allocatedMem->readGhostVariables.ghostDataTime,10,30,allocatedMem->buffer);
			copyBufferToScreen();
			pauseGame();
		}
		
		if (allocatedMem->recordGhost && p->numberOfLapDone==3\
		&& p->currentFPL < allocatedMem->saveFile->scores[p->mapNumber].best3Laps) {
			copyNewGhostToFile();
			allocatedMem->saveFile->scores[p->mapNumber].best3Laps = p->currentFPL;
			drawSexyString("New Record!",allocatedMem->buffer);
			copyBufferToScreen();
			while(!_keytest(RR_ENTER));
		}
		
	}
	

	homeScreenRestore//cf Define.h
	
	free(decompressedSprites);
	free(allocatedMem);
	
	restoreInt//cf Define.h	
	
	while (_keytest(RR_ENTER));
	GKeyFlush();
}

